package com.msl;

import com.google.common.collect.Sets;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.FilenameUtils;

import java.io.File;
import java.util.Set;

/**
 * @author wanglq
 * Date 2024/8/2
 * Time 17:06
 */
public class Main {
    public static Set<String> ignorePath = Sets.newHashSet();
    public static Set<String> suffix = Sets.newHashSet();

    static {
        ignorePath.add(".git");
        ignorePath.add(".idea");

        suffix.add("java");
        suffix.add("xml");
    }

    public static void main(String[] args) throws Exception {
//        doReplace("D:\\develop\\clx_projects\\msl-supervise\\supervise-web");
//        doReplace("D:\\develop\\clx_projects\\msl-common-starter\\log-spring-boot-starter");
//        doReplace("D:\\develop\\clx_projects\\msl-quality");
//        doReplace("D:\\develop\\clx_projects\\msl-message");
//        doReplace("D:\\develop\\clx_projects\\esign-non-standard-sdk");
//        doReplace("D:\\develop\\clx_projects\\msl-document\\document-api");
//        doReplace("D:\\develop\\clx_projects\\trade\\trade-settlement");
        doReplace("D:\\develop\\clx_projects\\trade\\trade-fund");
//        doReplace("D:\\develop\\clx_projects\\trade\\trade-performance\\trade-performance-api");
    }

    public static void doReplace(String path) throws Exception {
        File file = new File(path);
        if (!file.exists()) {
            System.out.println("路径不存在，无法替换……");
        }
        doReplace(file);
    }

    public static void doReplace(File file) throws Exception {
        if (file.isFile()) {
            String extension = FilenameUtils.getExtension(file.getName());
            if (!suffix.contains(extension)) {
                return;
            }
            FileContext context = new FileContext(file);
            System.out.println("处理文件:" + file.getName());
            FileUpdaterManager.update(context);
            //写回文件
            FileUtils.write(file, context.getContent(), "UTF-8");
        } else {
            if (ignorePath.contains(file.getName())) {
                return;
            }
            for (File childFile : file.listFiles()) {
                doReplace(childFile);
            }
        }
    }
}